﻿Imports System.IO

Public Class Problem
    Public ID As String
    Public Summary As String
    Public Message As String
    Public CreatedBy As String
    Public CreatedAt As Date
    Public Duration As String
    Public Acknowledge As Date
    Public Removed As Boolean
    Public Updated As Date

    Public Sub Load(ByRef sr As StreamReader, ByVal ID As String)
        Dim line As String
        Dim value() As String

        While Not sr.EndOfStream

            line = sr.ReadLine()
            If line = "" Then Exit While

            value = line.Split("=")
            If value.Length < 2 Then
                Dim err As New MalformedConfigFile
                err.Message = "Config file line contains no ""="" at " + line
                Throw err
            End If

            Select Case value(0)
                Case "Summary"
                    Me.Summary = value(1)
                Case "Message"
                    Me.Message = value(1).Replace("|", vbCrLf)
                Case "CreatedBy"
                    Me.CreatedBy = value(1)
                Case "CreatedAt"
                    Me.CreatedAt = value(1)
                Case "Duration"
                    Me.Duration = value(1)
                Case "Updated"
                    Me.Updated = value(1)
            End Select

        End While
        Me.ID = ID
    End Sub

    Public Sub Save(ByRef sw As StreamWriter)
        sw.WriteLine("[" + Me.ID + "]")
        sw.WriteLine("Summary=" + Me.Summary)
        sw.WriteLine("Message=" + Me.Message.Replace(vbCrLf, "|"))
        sw.WriteLine("CreatedBy=" + Me.CreatedBy)
        sw.WriteLine("CreatedAt=" + Me.CreatedAt)
        sw.WriteLine("Duration=" + Me.Duration)
        sw.WriteLine("Updated=" + Me.Updated)
        sw.WriteLine()
    End Sub

    Public Sub FillValues()
        Me.Summary = MainForm.TB_Summary.Text
        Me.CreatedAt = MainForm.TB_CreatedAt.Text
        Me.CreatedBy = MainForm.TB_CreatedBy.Text
        Me.Duration = MainForm.TB_Duration.Text
        Me.Message = MainForm.TB_Message.Text
        Me.ID = Me.CreatedAt
        Me.Updated = Now
    End Sub

End Class

Public Class MalformedConfigFile
    Inherits Exception
    Public Shadows Message As String
End Class
